# nn_send(3compat) Manual Page

## NAME

nn_send - send data (compatible API)

## SYNOPSIS

    #include <nanomsg/nn.h>

    int nn_send(int sock, const void *data, size_t size, int flags)

## DESCRIPTION

The `nn_send()` function creates a message containing data (of size size), and sends using the socket sock.

| This function is provided for API compatibility with legacy libnanomsg. Consider using the relevant modern API instead.

If size has the special value `NN_MSG`, then a zero-copy operation is performed. In this case, data points not to the message content itself, but instead is a pointer to the pointer, an extra level of pointer indirection. The message must have been previously allocated by `nn_allocmsg()` or `nn_recvmsg()``, using the same `NN_MSG` size. In this case, the ownership of the message shall remain with the caller, unless the function returns 0, indicating that the function has taken responsibility for delivering or disposing of the message.

The flags field may contain the special flag `NN_DONTWAIT`. In this case, if the socket is unable to accept more data for sending, the operation shall not block, but instead will fail with the error `EAGAIN`.

| The send operation is performed asynchronously, and may not have completed before this function returns control to the caller.

## RETURN VALUES

This function returns the number of bytes sent on success, and -1 on error.

## ERRORS

`EAGAIN` | The operation would block.
`EBADF` | The socket sock is not open.
`EFSM` | The socket cannot send in this state.
`ENOTSUP` | This protocol cannot send.
`ETIMEDOUT` | Operation timed out.

## SEE ALSO

nn_errno(3compat), nn_recv(3compat), nn_sendmsg(3compat), nn_socket(3compat), nn_compat(3compat), nng(7)